diff -durpN pgsql.orig/src/interfaces/ecpg/ecpglib/execute.c pgsql.1/src/interfaces/ecpg/ecpglib/execute.c
--- pgsql.orig/src/interfaces/ecpg/ecpglib/execute.c	2010-01-05 18:02:03.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/ecpglib/execute.c	2010-01-12 11:28:07.000000000 +0100
@@ -1662,7 +1662,7 @@ ecpg_execute(struct statement * stmt)
 }
 
 bool
-ECPGdo(const int lineno, const int compat, const int force_indicator, const char *connection_name, const bool questionmarks, const int st, const char *query,...)
+ECPGdo(const int lineno, const int compat, const int force_indicator, const int profile, const char *connection_name, const bool questionmarks, const int st, const char *query,...)
 {
 	va_list		args;
 	struct statement *stmt;
@@ -1673,6 +1673,7 @@ ECPGdo(const int lineno, const int compa
 	struct variable **list;
 	enum ECPG_statement_type statement_type = (enum ECPG_statement_type) st;
 	char	   *prepname;
+	struct timeval 	tv_start, tv_end;
 
 	if (!query)
 	{
@@ -1869,7 +1870,18 @@ ECPGdo(const int lineno, const int compa
 	/* initialize auto_mem struct */
 	ecpg_clear_auto_mem();
 
-	status = ecpg_execute(stmt);
+	/* perform execution and measure time */
+	if (profile)
+	{
+		gettimeofday(&tv_start, NULL);
+		status = ecpg_execute(stmt);
+		gettimeofday(&tv_end, NULL);
+		ecpg_account_query_time(lineno, connection_name, stmt->command, compat, &tv_start, &tv_end);
+	}
+	else
+		status = ecpg_execute(stmt);
+
+	/* clean out memory */
 	free_statement(stmt);
 
 	/* and reset locale value so our application is not affected */
@@ -1884,7 +1896,7 @@ bool
 ECPGdo_descriptor(int line, const char *connection,
 				  const char *descriptor, const char *query)
 {
-	return ECPGdo(line, ECPG_COMPAT_PGSQL, true, connection, '\0', 0, (char *) query, ECPGt_EOIT,
+	return ECPGdo(line, ECPG_COMPAT_PGSQL, true, false, connection, '\0', 0, (char *) query, ECPGt_EOIT,
 				  ECPGt_descriptor, descriptor, 0L, 0L, 0L,
 				  ECPGt_NO_INDICATOR, NULL, 0L, 0L, 0L, ECPGt_EORT);
 }
diff -durpN pgsql.orig/src/interfaces/ecpg/ecpglib/extern.h pgsql.1/src/interfaces/ecpg/ecpglib/extern.h
--- pgsql.orig/src/interfaces/ecpg/ecpglib/extern.h	2010-01-05 18:02:03.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/ecpglib/extern.h	2010-01-12 11:28:07.000000000 +0100
@@ -150,6 +150,7 @@ char	   *ecpg_prepared(const char *, str
 bool		ecpg_deallocate_all_conn(int lineno, enum COMPAT_MODE c, struct connection * conn);
 void		ecpg_log(const char *format,...);
 bool		ecpg_auto_prepare(int, const char *, const int, char **, const char *);
+void		ecpg_account_query_time(const int, const char *, const char *, enum COMPAT_MODE, struct timeval *, struct timeval *);
 void		ecpg_init_sqlca(struct sqlca_t * sqlca);
 
 struct sqlda_compat *ecpg_build_compat_sqlda(int, PGresult *, int, enum COMPAT_MODE);
diff -durpN pgsql.orig/src/interfaces/ecpg/ecpglib/prepare.c pgsql.1/src/interfaces/ecpg/ecpglib/prepare.c
--- pgsql.orig/src/interfaces/ecpg/ecpglib/prepare.c	2009-10-15 13:26:30.000000000 +0200
+++ pgsql.1/src/interfaces/ecpg/ecpglib/prepare.c	2010-01-12 11:28:07.000000000 +0100
@@ -4,6 +4,7 @@
 #include "postgres_fe.h"
 
 #include <ctype.h>
+#include <inttypes.h>
 
 #include "ecpgtype.h"
 #include "ecpglib.h"
@@ -28,12 +29,15 @@ typedef struct
 	char	   *ecpgQuery;
 	long		execs;			/* # of executions		*/
 	char	   *connection;		/* connection for the statement		*/
+	int64		total_execution_time;		/* total time spent in all calls */
+	int64		min_execution_time;		/* minimum execution time */
+	int64		max_execution_time;		/* maximum execution time */
 } stmtCacheEntry;
 
 static int	nextStmtID = 1;
 static const int stmtCacheNBuckets = 2039;		/* # buckets - a prime # */
 static const int stmtCacheEntPerBucket = 8;		/* # entries/bucket		*/
-static stmtCacheEntry stmtCacheEntries[16384] = {{0, {0}, 0, 0, 0}};
+static stmtCacheEntry stmtCacheEntries[16384] = {{0, {0}, 0, 0, 0, 0, 0, 0}};
 
 static struct prepared_statement *find_prepared_statement(const char *name,
 				 struct connection * con, struct prepared_statement ** prev);
@@ -458,6 +462,9 @@ AddStmtToCache(int lineno,		/* line # of
 	entry->ecpgQuery = ecpg_strdup(ecpgQuery, lineno);
 	entry->connection = (char *) connection;
 	entry->execs = 0;
+	entry->total_execution_time = 0;
+	entry->min_execution_time = 0;
+	entry->max_execution_time = 0;
 	memcpy(entry->stmtID, stmtID, sizeof(entry->stmtID));
 
 	return (entNo);
@@ -497,3 +504,80 @@ ecpg_auto_prepare(int lineno, const char
 
 	return (true);
 }
+
+/* account for execution time we have spent inside a prepared statement */
+void
+ecpg_account_query_time(const int lineno, const char *connection_name, const char *query, enum COMPAT_MODE compat, struct timeval *tv_start, struct timeval *tv_end)
+{
+	int			entNo;
+	int64			time_diff;
+	stmtCacheEntry	   *entry;
+
+	/* search the statement cache for this statement */
+	entNo = SearchStmtCache(query);
+
+	/* if not found - add the statement to the cache */
+	if (!entNo)
+	{
+		char	   *name;
+		ecpg_log("ecpg_account_query_time on line %d: statement not in cache; inserting\n", lineno);
+
+		/* generate a statement ID */
+		name = (char *) ecpg_alloc(STMTID_SIZE, lineno);
+		if (name == NULL)
+			return;
+		sprintf(name, "ecpg%d", nextStmtID++);
+
+		entNo = AddStmtToCache(lineno, name, connection_name, compat, query);
+		free(name);
+		if (entNo < 0)
+			return;
+	}
+	else
+		ecpg_log("ecpg_account_query_time on line %d: statement found in cache; entry %d\n", lineno, entNo);
+
+	entry = &stmtCacheEntries[entNo];
+
+	time_diff = 1000000 * ((int64)tv_end->tv_sec - (int64)tv_start->tv_sec)
+			+ (int64)tv_end->tv_usec - (int64)tv_start->tv_usec;
+
+	entry->total_execution_time += time_diff;
+	if (entry->max_execution_time < time_diff)
+		entry->max_execution_time = time_diff;
+	if ((entry->min_execution_time == 0) ||
+		(entry->min_execution_time > 0 && entry->min_execution_time > time_diff))
+		entry->min_execution_time = time_diff;
+}
+
+/*
+ * Report the collected query times
+ */
+void
+ECPGquery_timing_report(void)
+{
+	int	i, first = 1;
+	stmtCacheEntry	   *entry;
+
+	for (i = 0; i < 16384; i++)
+	{
+		entry = &stmtCacheEntries[i];
+		if (entry->stmtID[0] && entry->total_execution_time > 0)
+		{
+			if (first)
+			{
+				ecpg_log("Query execution times report\n");
+				ecpg_log("----------------------------\n");
+				first = 0;
+			}
+
+			ecpg_log("ID: '%s'\n", entry->stmtID);
+			ecpg_log("execution times: min: %" PRId64 " usecs; max: %" PRId64 " usecs; total: %" PRId64 " usecs\n",
+				entry->min_execution_time, entry->max_execution_time, entry->total_execution_time);
+			ecpg_log("Statement: %s\n", entry->ecpgQuery ? entry->ecpgQuery : "NULL");
+		}
+	}
+	if (first)
+	{
+		ecpg_log("Query execution time accounting was disabled or no accountable query was executed\n");
+	}
+}
diff -durpN pgsql.orig/src/interfaces/ecpg/include/ecpglib.h pgsql.1/src/interfaces/ecpg/include/ecpglib.h
--- pgsql.orig/src/interfaces/ecpg/include/ecpglib.h	2009-09-21 15:19:11.000000000 +0200
+++ pgsql.1/src/interfaces/ecpg/include/ecpglib.h	2010-01-12 11:28:07.000000000 +0100
@@ -11,6 +11,7 @@
 #include "ecpgtype.h"
 #include "sqlca.h"
 #include <string.h>
+#include <sys/time.h>
 
 #ifdef ENABLE_NLS
 extern char *
@@ -51,7 +52,7 @@ bool		ECPGstatus(int, const char *);
 bool		ECPGsetcommit(int, const char *, const char *);
 bool		ECPGsetconn(int, const char *);
 bool		ECPGconnect(int, int, const char *, const char *, const char *, const char *, int);
-bool		ECPGdo(const int, const int, const int, const char *, const bool, const int, const char *,...);
+bool		ECPGdo(const int, const int, const int, const int, const char *, const bool, const int, const char *,...);
 bool		ECPGtrans(int, const char *, const char *);
 bool		ECPGdisconnect(int, const char *);
 bool		ECPGprepare(int, const char *, const bool, const char *, const char *);
@@ -60,6 +61,7 @@ bool		ECPGdeallocate_all(int, int, const
 char	   *ECPGprepared_statement(const char *, const char *, int);
 PGconn	   *ECPGget_PGconn(const char *);
 PGTransactionStatusType ECPGtransactionStatus(const char *);
+void		ECPGquery_timing_report(void);
 
 char	   *ECPGerrmsg(void);
 
diff -durpN pgsql.orig/src/interfaces/ecpg/preproc/ecpg.c pgsql.1/src/interfaces/ecpg/preproc/ecpg.c
--- pgsql.orig/src/interfaces/ecpg/preproc/ecpg.c	2010-01-03 12:54:40.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/preproc/ecpg.c	2010-01-12 11:29:47.000000000 +0100
@@ -18,7 +18,8 @@ int			ret_value = 0,
 			force_indicator = true,
 			questionmarks = false,
 			regression_mode = false,
-			auto_prepare = false;
+			auto_prepare = false,
+			profile_statements = false;
 
 char	   *output_filename;
 
@@ -51,7 +52,7 @@ help(const char *progname)
 	printf(_("  -I DIRECTORY   search DIRECTORY for include files\n"));
 	printf(_("  -o OUTFILE     write result to OUTFILE\n"));
 	printf(_("  -r OPTION      specify run-time behavior; OPTION can be:\n"
-	 "                 \"no_indicator\", \"prepare\", \"questionmarks\"\n"));
+	 "                 \"no_indicator\", \"prepare\", \"profile\", \"questionmarks\"\n"));
 	printf(_("  --regression   run in regression testing mode\n"));
 	printf(_("  -t             turn on autocommit of transactions\n"));
 	printf(_("  --help         show this help, then exit\n"));
@@ -225,6 +226,8 @@ main(int argc, char *const argv[])
 			case 'r':
 				if (strcmp(optarg, "no_indicator") == 0)
 					force_indicator = false;
+				else if (strcmp(optarg, "profile") == 0)
+					profile_statements = true;
 				else if (strcmp(optarg, "prepare") == 0)
 					auto_prepare = true;
 				else if (strcmp(optarg, "questionmarks") == 0)
diff -durpN pgsql.orig/src/interfaces/ecpg/preproc/extern.h pgsql.1/src/interfaces/ecpg/preproc/extern.h
--- pgsql.orig/src/interfaces/ecpg/preproc/extern.h	2010-01-05 18:02:03.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/preproc/extern.h	2010-01-12 11:29:23.000000000 +0100
@@ -28,7 +28,8 @@ extern int	braces_open,
 			struct_level,
 			ecpg_informix_var,
 			regression_mode,
-			auto_prepare;
+			auto_prepare,
+			profile_statements;
 extern char *descriptor_index;
 extern char *descriptor_name;
 extern char *connection;
diff -durpN pgsql.orig/src/interfaces/ecpg/preproc/output.c pgsql.1/src/interfaces/ecpg/preproc/output.c
--- pgsql.orig/src/interfaces/ecpg/preproc/output.c	2009-12-16 11:30:27.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/preproc/output.c	2010-01-12 11:30:20.000000000 +0100
@@ -115,7 +115,7 @@ static char *ecpg_statement_type_name[] 
 void
 output_statement(char *stmt, int whenever_mode, enum ECPG_statement_type st)
 {
-	fprintf(yyout, "{ ECPGdo(__LINE__, %d, %d, %s, %d, ", compat, force_indicator, connection ? connection : "NULL", questionmarks);
+	fprintf(yyout, "{ ECPGdo(__LINE__, %d, %d, %d, %s, %d, ", compat, force_indicator, profile_statements, connection ? connection : "NULL", questionmarks);
 	if (st == ECPGst_execute || st == ECPGst_exec_immediate)
 	{
 		fprintf(yyout, "%s, %s, ", ecpg_statement_type_name[st], stmt);
diff -durpN pgsql.orig/src/interfaces/ecpg/test/expected/compat_informix-rnull.c pgsql.1/src/interfaces/ecpg/test/expected/compat_informix-rnull.c
--- pgsql.orig/src/interfaces/ecpg/test/expected/compat_informix-rnull.c	2008-12-30 15:28:02.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/test/expected/compat_informix-rnull.c	2010-01-12 11:39:32.000000000 +0100
@@ -105,7 +105,7 @@ if (sqlca.sqlcode < 0) sqlprint ( );}
 #line 29 "rnull.pgc"
 
 
-	{ ECPGdo(__LINE__, 1, 0, NULL, 0, ECPGst_normal, "create table test ( id int , c char ( 10 ) , s smallint , i int , b bool , f float , l bigint , dbl double precision , dec decimal , dat date , tmp timestamptz )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 0, 0, NULL, 0, ECPGst_normal, "create table test ( id int , c char ( 10 ) , s smallint , i int , b bool , f float , l bigint , dbl double precision , dec decimal , dat date , tmp timestamptz )", ECPGt_EOIT, ECPGt_EORT);
 #line 33 "rnull.pgc"
 
 if (sqlca.sqlcode < 0) sqlprint ( );}
@@ -118,7 +118,7 @@ if (sqlca.sqlcode < 0) sqlprint ( );}
 #line 34 "rnull.pgc"
 
 
-	{ ECPGdo(__LINE__, 1, 0, NULL, 0, ECPGst_normal, "insert into test ( id , c , s , i , b , f , l , dbl ) values ( 1 , $1  , $2  , $3  , $4  , $5  , $6  , $7  )", 
+	{ ECPGdo(__LINE__, 1, 0, 0, NULL, 0, ECPGst_normal, "insert into test ( id , c , s , i , b , f , l , dbl ) values ( 1 , $1  , $2  , $3  , $4  , $5  , $6  , $7  )", 
 	ECPGt_char,(c),(long)sizeof("abc"),(long)1,(sizeof("abc"))*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
 	ECPGt_short,&(s),(long)1,(long)1,sizeof(short), 
@@ -156,7 +156,7 @@ if (sqlca.sqlcode < 0) sqlprint ( );}
 	rsetnull(CDATETYPE, (char *) &dat);
 	rsetnull(CDTIMETYPE, (char *) &tmp);
 
-	{ ECPGdo(__LINE__, 1, 0, NULL, 0, ECPGst_normal, "insert into test ( id , c , s , i , b , f , l , dbl , dec , dat , tmp ) values ( 2 , $1  , $2  , $3  , $4  , $5  , $6  , $7  , $8  , $9  , $10  )", 
+	{ ECPGdo(__LINE__, 1, 0, 0, NULL, 0, ECPGst_normal, "insert into test ( id , c , s , i , b , f , l , dbl , dec , dat , tmp ) values ( 2 , $1  , $2  , $3  , $4  , $5  , $6  , $7  , $8  , $9  , $10  )", 
 	ECPGt_char,(c),(long)sizeof("abc"),(long)1,(sizeof("abc"))*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
 	ECPGt_short,&(s),(long)1,(long)1,sizeof(short), 
@@ -191,7 +191,7 @@ if (sqlca.sqlcode < 0) sqlprint ( );}
 
 	printf("first select\n");
 
-	{ ECPGdo(__LINE__, 1, 0, NULL, 0, ECPGst_normal, "select c , s , i , b , f , l , dbl , dec , dat , tmp from test where id = 1", ECPGt_EOIT, 
+	{ ECPGdo(__LINE__, 1, 0, 0, NULL, 0, ECPGst_normal, "select c , s , i , b , f , l , dbl , dec , dat , tmp from test where id = 1", ECPGt_EOIT, 
 	ECPGt_char,(c),(long)sizeof("abc"),(long)1,(sizeof("abc"))*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
 	ECPGt_short,&(s),(long)1,(long)1,sizeof(short), 
@@ -231,7 +231,7 @@ if (sqlca.sqlcode < 0) sqlprint ( );}
 
 	printf("second select\n");
 
-	{ ECPGdo(__LINE__, 1, 0, NULL, 0, ECPGst_normal, "select c , s , i , b , f , l , dbl , dec , dat , tmp from test where id = 2", ECPGt_EOIT, 
+	{ ECPGdo(__LINE__, 1, 0, 0, NULL, 0, ECPGst_normal, "select c , s , i , b , f , l , dbl , dec , dat , tmp from test where id = 2", ECPGt_EOIT, 
 	ECPGt_char,(c),(long)sizeof("abc"),(long)1,(sizeof("abc"))*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
 	ECPGt_short,&(s),(long)1,(long)1,sizeof(short), 
@@ -269,7 +269,7 @@ if (sqlca.sqlcode < 0) sqlprint ( );}
 	test_null(CDATETYPE, (char *) &dat);
 	test_null(CDTIMETYPE, (char *) &tmp);
 
-	{ ECPGdo(__LINE__, 1, 0, NULL, 0, ECPGst_normal, "drop table test", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 0, 0, NULL, 0, ECPGst_normal, "drop table test", ECPGt_EOIT, ECPGt_EORT);
 #line 91 "rnull.pgc"
 
 if (sqlca.sqlcode < 0) sqlprint ( );}
diff -durpN pgsql.orig/src/interfaces/ecpg/test/expected/compat_informix-sqlda.c pgsql.1/src/interfaces/ecpg/test/expected/compat_informix-sqlda.c
--- pgsql.orig/src/interfaces/ecpg/test/expected/compat_informix-sqlda.c	2010-01-06 19:06:37.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/test/expected/compat_informix-sqlda.c	2010-01-12 11:39:32.000000000 +0100
@@ -192,7 +192,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "set");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "set datestyle to iso", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "set datestyle to iso", ECPGt_EOIT, ECPGt_EORT);
 #line 71 "sqlda.pgc"
 
 if (sqlca.sqlcode < 0) exit (1);}
@@ -200,7 +200,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "create");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "create table t1 ( id integer , t text , d1 numeric , d2 float8 , c char ( 10 ) )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "create table t1 ( id integer , t text , d1 numeric , d2 float8 , c char ( 10 ) )", ECPGt_EOIT, ECPGt_EORT);
 #line 79 "sqlda.pgc"
 
 if (sqlca.sqlcode < 0) exit (1);}
@@ -208,7 +208,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "insert");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "insert into t1 values ( 1 , 'a' , 1.0 , 1 , 'a' ) , ( 2 , null , null , null , null ) , ( 4 , 'd' , 4.0 , 4 , 'd' )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "insert into t1 values ( 1 , 'a' , 1.0 , 1 , 'a' ) , ( 2 , null , null , null , null ) , ( 4 , 'd' , 4.0 , 4 , 'd' )", ECPGt_EOIT, ECPGt_EORT);
 #line 85 "sqlda.pgc"
 
 if (sqlca.sqlcode < 0) exit (1);}
@@ -241,7 +241,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "open");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "declare mycur1 cursor for $1", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "declare mycur1 cursor for $1", 
 	ECPGt_char_variable,(ECPGprepared_statement(NULL, "st_id1", __LINE__)),(long)1,(long)1,(1)*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
 #line 101 "sqlda.pgc"
@@ -258,7 +258,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 	while (1)
 	{
 		strcpy(msg, "fetch");
-		{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "fetch 1 from mycur1", ECPGt_EOIT, 
+		{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "fetch 1 from mycur1", ECPGt_EOIT, 
 	ECPGt_sqlda, &outp_sqlda, 0L, 0L, 0L, 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
 #line 109 "sqlda.pgc"
@@ -279,7 +279,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "close");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "close mycur1", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "close mycur1", ECPGt_EOIT, ECPGt_EORT);
 #line 118 "sqlda.pgc"
 
 if (sqlca.sqlcode < 0) exit (1);}
@@ -316,7 +316,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "open");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "declare mycur2 cursor for $1", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "declare mycur2 cursor for $1", 
 	ECPGt_char_variable,(ECPGprepared_statement(NULL, "st_id2", __LINE__)),(long)1,(long)1,(1)*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
 #line 138 "sqlda.pgc"
@@ -333,7 +333,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 	while (1)
 	{
 		strcpy(msg, "fetch");
-		{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "fetch from mycur2", ECPGt_EOIT, 
+		{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "fetch from mycur2", ECPGt_EOIT, 
 	ECPGt_sqlda, &outp_sqlda, 0L, 0L, 0L, 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
 #line 146 "sqlda.pgc"
@@ -354,7 +354,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "close");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "close mycur2", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "close mycur2", ECPGt_EOIT, ECPGt_EORT);
 #line 155 "sqlda.pgc"
 
 if (sqlca.sqlcode < 0) exit (1);}
@@ -398,7 +398,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "execute");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_execute, "st_id3", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_execute, "st_id3", 
 	ECPGt_sqlda, &inp_sqlda, 0L, 0L, 0L, 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
 	ECPGt_sqlda, &outp_sqlda, 0L, 0L, 0L, 
@@ -459,7 +459,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 
 
 	strcpy(msg, "execute");
-	{ ECPGdo(__LINE__, 1, 1, "con2", 0, ECPGst_execute, "st_id4", 
+	{ ECPGdo(__LINE__, 1, 1, 0, "con2", 0, ECPGst_execute, "st_id4", 
 	ECPGt_sqlda, &inp_sqlda, 0L, 0L, 0L, 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
 	ECPGt_sqlda, &outp_sqlda, 0L, 0L, 0L, 
@@ -503,7 +503,7 @@ if (sqlca.sqlcode < 0) exit (1);}
 	/* End test */
 
 	strcpy(msg, "drop");
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "drop table t1", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "drop table t1", ECPGt_EOIT, ECPGt_EORT);
 #line 241 "sqlda.pgc"
 
 if (sqlca.sqlcode < 0) exit (1);}
diff -durpN pgsql.orig/src/interfaces/ecpg/test/expected/compat_informix-test_informix2.c pgsql.1/src/interfaces/ecpg/test/expected/compat_informix-test_informix2.c
--- pgsql.orig/src/interfaces/ecpg/test/expected/compat_informix-test_informix2.c	2008-12-30 15:28:02.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/test/expected/compat_informix-test_informix2.c	2010-01-12 11:39:32.000000000 +0100
@@ -179,14 +179,14 @@ if (sqlca.sqlcode < 0) sqlprint();}
 
 	sql_check("main", "connect", 0);
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "set DateStyle to 'DMY'", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "set DateStyle to 'DMY'", ECPGt_EOIT, ECPGt_EORT);
 #line 66 "test_informix2.pgc"
 
 if (sqlca.sqlcode < 0) sqlprint();}
 #line 66 "test_informix2.pgc"
 
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "create table history ( customerid integer , timestamp timestamp without time zone , action_taken char ( 5 ) , narrative varchar ( 100 ) )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "create table history ( customerid integer , timestamp timestamp without time zone , action_taken char ( 5 ) , narrative varchar ( 100 ) )", ECPGt_EOIT, ECPGt_EORT);
 #line 68 "test_informix2.pgc"
 
 if (sqlca.sqlcode < 0) sqlprint();}
@@ -194,7 +194,7 @@ if (sqlca.sqlcode < 0) sqlprint();}
 
 	sql_check("main", "create", 0);
 	
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "insert into history ( customerid , timestamp , action_taken , narrative ) values ( 1 , '2003-05-07 13:28:34 CEST' , 'test' , 'test' )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "insert into history ( customerid , timestamp , action_taken , narrative ) values ( 1 , '2003-05-07 13:28:34 CEST' , 'test' , 'test' )", ECPGt_EOIT, ECPGt_EORT);
 #line 73 "test_informix2.pgc"
 
 if (sqlca.sqlcode < 0) sqlprint();}
@@ -202,7 +202,7 @@ if (sqlca.sqlcode < 0) sqlprint();}
 
 	sql_check("main", "insert", 0);
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "select max ( timestamp ) from history", ECPGt_EOIT, 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "select max ( timestamp ) from history", ECPGt_EOIT, 
 	ECPGt_timestamp,&(maxd),(long)1,(long)1,sizeof(timestamp), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
 #line 78 "test_informix2.pgc"
@@ -212,7 +212,7 @@ if (sqlca.sqlcode < 0) sqlprint();}
 
 	sql_check("main", "select max", 100);
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "select customerid , timestamp from history where timestamp = $1  limit 1", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "select customerid , timestamp from history where timestamp = $1  limit 1", 
 	ECPGt_timestamp,&(maxd),(long)1,(long)1,sizeof(timestamp), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, 
 	ECPGt_int,&(c),(long)1,(long)1,sizeof(int), 
@@ -233,7 +233,7 @@ if (sqlca.sqlcode < 0) sqlprint();}
 	free(intvl);
 	c++;
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "insert into history ( customerid , timestamp , action_taken , narrative ) values ( $1  , $2  , 'test' , 'test' )", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "insert into history ( customerid , timestamp , action_taken , narrative ) values ( $1  , $2  , 'test' , 'test' )", 
 	ECPGt_int,&(c),(long)1,(long)1,sizeof(int), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
 	ECPGt_timestamp,&(e),(long)1,(long)1,sizeof(timestamp), 
@@ -252,7 +252,7 @@ if (sqlca.sqlcode < 0) sqlprint();}
 #line 100 "test_informix2.pgc"
 
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "drop table history", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "drop table history", ECPGt_EOIT, ECPGt_EORT);
 #line 102 "test_informix2.pgc"
 
 if (sqlca.sqlcode < 0) sqlprint();}
diff -durpN pgsql.orig/src/interfaces/ecpg/test/expected/compat_informix-test_informix.c pgsql.1/src/interfaces/ecpg/test/expected/compat_informix-test_informix.c
--- pgsql.orig/src/interfaces/ecpg/test/expected/compat_informix-test_informix.c	2009-11-11 20:47:12.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/test/expected/compat_informix-test_informix.c	2010-01-12 11:39:32.000000000 +0100
@@ -63,7 +63,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 	if (sqlca.sqlcode != 0) exit(1);
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "create table test ( i int primary key , j int , c text )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "create table test ( i int primary key , j int , c text )", ECPGt_EOIT, ECPGt_EORT);
 #line 24 "test_informix.pgc"
 
 if (sqlca.sqlcode < 0) dosqlprint ( );}
@@ -72,7 +72,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 	/* this INSERT works */
 	rsetnull(CDECIMALTYPE, (char *)&j);
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "insert into test ( i , j , c ) values ( 7 , $1  , 'test   ' )", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "insert into test ( i , j , c ) values ( 7 , $1  , 'test   ' )", 
 	ECPGt_decimal,&(j),(long)1,(long)1,sizeof(decimal), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
 #line 28 "test_informix.pgc"
@@ -88,7 +88,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 
 	/* this INSERT should fail because i is a unique column */
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "insert into test ( i , j , c ) values ( 7 , 12 , 'a' )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "insert into test ( i , j , c ) values ( 7 , 12 , 'a' )", ECPGt_EOIT, ECPGt_EORT);
 #line 32 "test_informix.pgc"
 
 if (sqlca.sqlcode < 0) dosqlprint ( );}
@@ -102,7 +102,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 #line 34 "test_informix.pgc"
 
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "insert into test ( i , j , c ) values ( $1  , 1 , 'a      ' )", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "insert into test ( i , j , c ) values ( $1  , 1 , 'a      ' )", 
 	ECPGt_int,&(i),(long)1,(long)1,sizeof(int), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
 #line 36 "test_informix.pgc"
@@ -118,7 +118,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 
 	/* this will fail (more than one row in subquery) */
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "select i from test where j = ( select j from test )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "select i from test where j = ( select j from test )", ECPGt_EOIT, ECPGt_EORT);
 #line 40 "test_informix.pgc"
 
 if (sqlca.sqlcode < 0) dosqlprint ( );}
@@ -132,7 +132,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 
 	/* this however should be ok */
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "select i from test where j = ( select j from test order by i limit 1 )", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "select i from test where j = ( select j from test order by i limit 1 )", ECPGt_EOIT, ECPGt_EORT);
 #line 44 "test_informix.pgc"
 
 if (sqlca.sqlcode < 0) dosqlprint ( );}
@@ -158,7 +158,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 	while (1)
 	{
-		{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "fetch forward c", ECPGt_EOIT, 
+		{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "fetch forward c", ECPGt_EOIT, 
 	ECPGt_int,&(i),(long)1,(long)1,sizeof(int), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
 	ECPGt_decimal,&(j),(long)1,(long)1,sizeof(decimal), 
@@ -187,7 +187,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 	deccvint(7, &j);
 	deccvint(14, &m);
 	decadd(&j, &m, &n);
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "delete from test where i = $1  :: decimal", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "delete from test where i = $1  :: decimal", 
 	ECPGt_decimal,&(n),(long)1,(long)1,sizeof(decimal), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
 #line 75 "test_informix.pgc"
@@ -197,7 +197,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 	printf("DELETE: %ld\n", sqlca.sqlcode);
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "select 1 from test where i = 14", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "select 1 from test where i = 14", ECPGt_EOIT, ECPGt_EORT);
 #line 78 "test_informix.pgc"
 
 if (sqlca.sqlcode < 0) dosqlprint ( );}
@@ -205,7 +205,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 	printf("Exists: %ld\n", sqlca.sqlcode);
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "select 1 from test where i = 147", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "select 1 from test where i = 147", ECPGt_EOIT, ECPGt_EORT);
 #line 81 "test_informix.pgc"
 
 if (sqlca.sqlcode < 0) dosqlprint ( );}
@@ -219,7 +219,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 if (sqlca.sqlcode < 0) dosqlprint ( );}
 #line 84 "test_informix.pgc"
 
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "drop table test", ECPGt_EOIT, ECPGt_EORT);
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "drop table test", ECPGt_EOIT, ECPGt_EORT);
 #line 85 "test_informix.pgc"
 
 if (sqlca.sqlcode < 0) dosqlprint ( );}
@@ -244,7 +244,7 @@ if (sqlca.sqlcode < 0) dosqlprint ( );}
 
 static void openit(void)
 {
-	{ ECPGdo(__LINE__, 1, 1, NULL, 0, ECPGst_normal, "declare c cursor for select * from test where i <= $1 ", 
+	{ ECPGdo(__LINE__, 1, 1, 0, NULL, 0, ECPGst_normal, "declare c cursor for select * from test where i <= $1 ", 
 	ECPGt_int,&(*( int  *)(ECPG_informix_get_var( 0))),(long)1,(long)1,sizeof(int), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
 #line 95 "test_informix.pgc"
diff -durpN pgsql.orig/src/interfaces/ecpg/test/expected/connect-test2.c pgsql.1/src/interfaces/ecpg/test/expected/connect-test2.c
--- pgsql.orig/src/interfaces/ecpg/test/expected/connect-test2.c	2008-12-30 15:28:02.000000000 +0100
+++ pgsql.1/src/interfaces/ecpg/test/expected/connect-test2.c	2010-01-12 11:39:33.000000000 +0100
@@ -55,17 +55,17 @@ main(void)
 
 
 	/* this selects from "second" which was opened last */
-	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
+	{ ECPGdo(__LINE__, 0, 1, 0, NULL, 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
 	ECPGt_char,(res),(long)200,(long)1,(200)*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
 #line 28 "test2.pgc"
 
-	{ ECPGdo(__LINE__, 0, 1, "first", 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
+	{ ECPGdo(__LINE__, 0, 1, 0, "first", 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
 	ECPGt_char,(res),(long)200,(long)1,(200)*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
 #line 29 "test2.pgc"
 
-	{ ECPGdo(__LINE__, 0, 1, "second", 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
+	{ ECPGdo(__LINE__, 0, 1, 0, "second", 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
 	ECPGt_char,(res),(long)200,(long)1,(200)*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
 #line 30 "test2.pgc"
@@ -74,7 +74,7 @@ main(void)
 	{ ECPGsetconn(__LINE__, "first");}
 #line 32 "test2.pgc"
 
-	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
+	{ ECPGdo(__LINE__, 0, 1, 0, NULL, 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
 	ECPGt_char,(res),(long)200,(long)1,(200)*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
 #line 33 "test2.pgc"
@@ -84,7 +84,7 @@ main(void)
 	{ ECPGdisconnect(__LINE__, "CURRENT");}
 #line 36 "test2.pgc"
 
-	{ ECPGdo(__LINE__, 0, 1, NULL, 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
+	{ ECPGdo(__LINE__, 0, 1, 0, NULL, 0, ECPGst_normal, "select current_database ( )", ECPGt_EOIT, 
 	ECPGt_char,(res),(long)200,(long)1,(200)*sizeof(char), 
 	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);}
 #line 37 "test2.pgc"
